Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# Lens Class Reference

A base class for any number of different kinds of lenses, linear and otherwise. More...

Inheritance diagram for Lens:

List of all members.

## Public Types
enum | FromCorners { FCRoll = 1, FCCameraPlane = 2, FCOffAxis = 4, FCAspectRatio = 8, FCShear = 16, FCKeystone = 32 }
enum | StereoChannel { SCMono = 0, SCLeft = 1, SCRight = 2, SCStereo = 3 }
## Public Member Functions
| clear ()
| Resets all lens parameters to their initial default settings.
| clearKeystone ()
| Disables the lens keystone correction.
| clearViewMat ()
| Resets the lens transform to identity.
bool | extrude (Point3 const point2d, Point3 near_point, Point3 far_point)
| Given a 2-d point in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner, compute the corresponding vector in space that maps to this point, if such a vector can be determined.
bool | extrude (Point2 const point2d, Point3 near_point, Point3 far_point)
| Given a 2-d point in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner, compute the corresponding vector in space that maps to this point, if such a vector can be determined.
bool | extrudeVec (Point2 const point2d, Vec3 vec3d)
| Given a 2-d point in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner, compute the vector that corresponds to the view direction.
bool | extrudeVec (Point3 const point2d, Vec3 vec3d)
| Given a 2-d point in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner, compute the vector that corresponds to the view direction.
float | getAspectRatio ()
| Returns the aspect ratio of the Lens.
string | getChangeEvent ()
| Returns the name of the event that will be generated whenever any properties of this particular Lens have changed.
float | getConvergenceDistance ()
| See set_convergence_distance().
CoordinateSystem | getCoordinateSystem ()
| Returns the coordinate system that all 3-d computations are performed within for this Lens.
float | getFar ()
| Returns the position of the far plane (or cylinder, sphere, whatever).
Mat4 const | getFilmMat ()
| Returns the matrix that transforms from a point behind the lens to a point on the film.
Mat4 const | getFilmMatInv ()
| Returns the matrix that transforms from a point on the film to a point behind the lens.
Vec2 const | getFilmOffset ()
| Returns the horizontal and vertical offset amounts of this Lens.
VBase2 const | getFilmSize ()
| Returns the horizontal and vertical film size of the virtual film.
float | getFocalLength ()
| Returns the focal length of the lens.
VBase2 const | getFov ()
| Returns the horizontal and vertical film size of the virtual film.
float | getHfov ()
| Returns the horizontal component of fov only.
float | getInterocularDistance ()
| See set_interocular_distance().
VBase2 const | getKeystone ()
| Returns the keystone correction specified for the lens.
UpdateSeq | getLastChange ()
| Returns the UpdateSeq that is incremented whenever the lens properties are changed.
Mat4 const | getLensMat ()
| Returns the matrix that transforms from a point in front of the lens to a point in space.
Mat4 const | getLensMatInv ()
| Returns the matrix that transforms from a point in space to a point in front of the lens.
float | getMinFov ()
| Returns the field of view of the narrowest dimension of the window.
float | getNear ()
| Returns the position of the near plane (or cylinder, sphere, whatever).
Point3 | getNodalPoint ()
| Returns the center point of the lens: the point from which the lens is viewing.
Mat4 const | getProjectionMat (StereoChannel channel)
| Returns the complete transformation matrix from a 3-d point in space to a point on the film, if such a matrix exists, or the identity matrix if the lens is nonlinear.
Mat4 const | getProjectionMat ()
| Returns the complete transformation matrix from a 3-d point in space to a point on the film, if such a matrix exists, or the identity matrix if the lens is nonlinear.
Mat4 const | getProjectionMatInv (StereoChannel channel)
| Returns the matrix that transforms from a 2-d point on the film to a 3-d vector in space, if such a matrix exists.
Mat4 const | getProjectionMatInv ()
| Returns the matrix that transforms from a 2-d point on the film to a 3-d vector in space, if such a matrix exists.
Vec3 const | getUpVector ()
| Returns the axis perpendicular to the camera's view vector that indicates the "up" direction.
float | getVfov ()
| Returns the vertical component of fov only.
VBase3 const | getViewHpr ()
| Returns the direction in which the lens is facing.
Mat4 const | getViewMat ()
| Returns the direction in which the lens is facing.
Vec3 const | getViewVector ()
| Returns the axis along which the lens is facing.
bool | isLinear ()
| Returns true if the lens represents a linear projection (e.g.
bool | isOrthographic ()
| Returns true if the lens represents a orthographic projection (i.e.
bool | isPerspective ()
| Returns true if the lens represents a perspective projection (i.e.
BoundingVolume | makeBounds ()
| Allocates and returns a new BoundingVolume that encloses the frustum used for this kind of lens, if possible.
Lens | makeCopy ()
Geom | makeGeometry ()
| Allocates and returns a new Geom that can be rendered to show a visible representation of the frustum used for this kind of lens, if it makes sense to do so.
| output (ostream out)
bool | project (Point3 const point3d, Point3 point2d)
| Given a 3-d point in space, determine the 2-d point this maps to, in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner.
bool | project (Point3 const point3d, Point2 point2d)
| Given a 3-d point in space, determine the 2-d point this maps to, in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner.
| recomputeAll ()
| Forces all internal parameters of the Lens to be recomputed.
| setAspectRatio (float aspect_ratio)
| Sets the aspect ratio of the lens.
| setChangeEvent (string event)
| Sets the name of the event that will be generated whenever any properties of the Lens have changed.
| setConvergenceDistance (float convergence_distance)
| Sets the distance between between the camera plane and the point in the distance that the left and right eyes are both looking at.
| setCoordinateSystem (CoordinateSystem cs)
| Specifies the coordinate system that all 3-d computations are performed within for this Lens.
| setFar (float far_distance)
| Defines the position of the far plane (or cylinder, sphere, whatever).
| setFilmOffset (float x, float y)
| Sets the horizontal and vertical offset amounts of this Lens.
| setFilmOffset (VBase2 const film_offset)
| Sets the horizontal and vertical offset amounts of this Lens.
| setFilmSize (VBase2 const film_size)
| Sets the size and shape of the "film" within the lens.
| setFilmSize (float width, float height)
| Sets the size and shape of the "film" within the lens.
| setFilmSize (float width)
| Sets the horizontal size of the film without changing its shape.
| setFocalLength (float focal_length)
| Sets the focal length of the lens.
| setFov (float hfov, float vfov)
| Sets the field of view of the lens in both dimensions.
| setFov (float fov)
| Sets the horizontal field of view of the lens without changing the aspect ratio.
| setFov (VBase2 const fov)
| Sets the field of view of the lens in both dimensions.
| setFrustumFromCorners (VBase3 const ul, VBase3 const ur, VBase3 const ll, VBase3 const lr, int flags)
| Sets up the lens to use the frustum defined by the four indicated points.
| setInterocularDistance (float interocular_distance)
| Sets the distance between the left and right eyes of a stereo camera.
| setKeystone (VBase2 const keystone)
| Indicates the ratio of keystone correction to perform on the lens, in each of three axes.
| setMinFov (float min_fov)
| Sets the field of view of the smallest dimension of the window.
| setNear (float near_distance)
| Defines the position of the near plane (or cylinder, sphere, whatever).
| setNearFar (float near_distance, float far_distance)
| Simultaneously changes the near and far planes.
| setViewHpr (float h, float p, float r)
| Sets the direction in which the lens is facing.
| setViewHpr (VBase3 const view_hpr)
| Sets the direction in which the lens is facing.
| setViewMat (Mat4 const view_mat)
| Sets an arbitrary transformation on the lens.
| setViewVector (float x, float y, float z, float i, float j, float k)
| Specifies the direction in which the lens is facing by giving an axis to look along, and a perpendicular (or at least non-parallel) up axis.
| setViewVector (Vec3 const view_vector, Vec3 const up_vector)
| Specifies the direction in which the lens is facing by giving an axis to look along, and a perpendicular (or at least non-parallel) up axis.
| write (ostream out)
| write (ostream out, int indent_level)
## Static Public Member Functions
static TypeHandle | getClassType ()
static float | getDefaultFar ()
| Returns the default far plane distance that will be assigned to each newly-created lens.
static float | getDefaultNear ()
| Returns the default near plane distance that will be assigned to each newly-created lens.

## Detailed Description

A base class for any number of different kinds of lenses, linear and otherwise.

Presently, this includes perspective and orthographic lenses.

A Lens object is the main part of a Camera node, which defines the fundamental interface to point-of-view for rendering. Lenses are also used in other contexts, however; for instance, a Spotlight is also defined using a lens.

## Member Enumeration Documentation

enum FromCorners

Enumerator:

  FCRoll |
  FCCameraPlane |
  FCOffAxis |
  FCAspectRatio |
  FCShear |
  FCKeystone |

enum StereoChannel

Enumerator:

  SCMono |
  SCLeft |
  SCRight |
  SCStereo |

## Member Function Documentation

clear | ( |  | ) |

Resets all lens parameters to their initial default settings.

clearKeystone | ( |  | ) |

Disables the lens keystone correction.

clearViewMat | ( |  | ) |

Resets the lens transform to identity.

bool extrude | ( | Point2 const | point2d,
|  | Point3 | near_point,
|  | Point3 | far_point
| ) |  |

Given a 2-d point in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner, compute the corresponding vector in space that maps to this point, if such a vector can be determined.

The vector is returned by indicating the points on the near plane and far plane that both map to the indicated 2-d point.

Returns true if the vector is defined, or false otherwise.

bool extrude | ( | Point3 const | point2d,
|  | Point3 | near_point,
|  | Point3 | far_point
| ) |  |

Given a 2-d point in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner, compute the corresponding vector in space that maps to this point, if such a vector can be determined.

The vector is returned by indicating the points on the near plane and far plane that both map to the indicated 2-d point.

The z coordinate of the 2-d point is ignored.

Returns true if the vector is defined, or false otherwise.

bool extrudeVec | ( | Point2 const | point2d,
|  | Vec3 | vec3d
| ) |  |

Given a 2-d point in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner, compute the vector that corresponds to the view direction.

This will be parallel to the normal on the surface (the far plane) corresponding to the lens shape at this point.

See the comment block on Lens.extrude_vec_impl() for a more in-depth comment on the meaning of this vector.

Returns true if the vector is defined, or false otherwise.

bool extrudeVec | ( | Point3 const | point2d,
|  | Vec3 | vec3d
| ) |  |

Given a 2-d point in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner, compute the vector that corresponds to the view direction.

This will be parallel to the normal on the surface (the far plane) corresponding to the lens shape at this point.

See the comment block on Lens.extrude_vec_impl() for a more in-depth comment on the meaning of this vector.

The z coordinate of the 2-d point is ignored.

Returns true if the vector is defined, or false otherwise.

float getAspectRatio | ( |  | ) |

Returns the aspect ratio of the Lens.

This is determined based on the indicated film size; see set_film_size().

string getChangeEvent | ( |  | ) |

Returns the name of the event that will be generated whenever any properties of this particular Lens have changed.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedWritableReferenceCount.

Reimplemented in MatrixLens, OrthographicLens, and PerspectiveLens.

float getConvergenceDistance | ( |  | ) |

See set_convergence_distance().

CoordinateSystem getCoordinateSystem | ( |  | ) |

Returns the coordinate system that all 3-d computations are performed within for this Lens.

Normally, this is CS_default.

static float getDefaultFar | ( |  | ) | `[static]`

Returns the default far plane distance that will be assigned to each newly-created lens.

This is read from the Configrc file.

static float getDefaultNear | ( |  | ) | `[static]`

Returns the default near plane distance that will be assigned to each newly-created lens.

This is read from the Configrc file.

float getFar | ( |  | ) |

Returns the position of the far plane (or cylinder, sphere, whatever).

Mat4 const getFilmMat | ( |  | ) |

Returns the matrix that transforms from a point behind the lens to a point on the film.

Mat4 const getFilmMatInv | ( |  | ) |

Returns the matrix that transforms from a point on the film to a point behind the lens.

Vec2 const getFilmOffset | ( |  | ) |

Returns the horizontal and vertical offset amounts of this Lens.

See set_film_offset().

VBase2 const getFilmSize | ( |  | ) |

Returns the horizontal and vertical film size of the virtual film.

See set_film_size().

float getFocalLength | ( |  | ) |

Returns the focal length of the lens.

This may have been set explicitly by a previous call to set_focal_length(), or it may be computed based on the lens' fov and film_size. For certain kinds of lenses, the focal length has no meaning.

VBase2 const getFov | ( |  | ) |

Returns the horizontal and vertical film size of the virtual film.

See set_fov().

float getHfov | ( |  | ) |

Returns the horizontal component of fov only.

See get_fov().

float getInterocularDistance | ( |  | ) |

See set_interocular_distance().

VBase2 const getKeystone | ( |  | ) |

Returns the keystone correction specified for the lens.

UpdateSeq getLastChange | ( |  | ) |

Returns the UpdateSeq that is incremented whenever the lens properties are changed.

As long as this number remains the same, you may assume the lens properties are unchanged.

Mat4 const getLensMat | ( |  | ) |

Returns the matrix that transforms from a point in front of the lens to a point in space.

Mat4 const getLensMatInv | ( |  | ) |

Returns the matrix that transforms from a point in space to a point in front of the lens.

float getMinFov | ( |  | ) |

Returns the field of view of the narrowest dimension of the window.

See set_min_fov().

float getNear | ( |  | ) |

Returns the position of the near plane (or cylinder, sphere, whatever).

Point3 getNodalPoint | ( |  | ) |

Returns the center point of the lens: the point from which the lens is viewing.

Mat4 const getProjectionMat | ( | StereoChannel | channel | ) |

Returns the complete transformation matrix from a 3-d point in space to a point on the film, if such a matrix exists, or the identity matrix if the lens is nonlinear.

Mat4 const getProjectionMat | ( |  | ) |

Returns the complete transformation matrix from a 3-d point in space to a point on the film, if such a matrix exists, or the identity matrix if the lens is nonlinear.

Mat4 const getProjectionMatInv | ( | StereoChannel | channel | ) |

Returns the matrix that transforms from a 2-d point on the film to a 3-d vector in space, if such a matrix exists.

Mat4 const getProjectionMatInv | ( |  | ) |

Returns the matrix that transforms from a 2-d point on the film to a 3-d vector in space, if such a matrix exists.

Vec3 const getUpVector | ( |  | ) |

Returns the axis perpendicular to the camera's view vector that indicates the "up" direction.

float getVfov | ( |  | ) |

Returns the vertical component of fov only.

See get_fov().

VBase3 const getViewHpr | ( |  | ) |

Returns the direction in which the lens is facing.

Mat4 const getViewMat | ( |  | ) |

Returns the direction in which the lens is facing.

Vec3 const getViewVector | ( |  | ) |

Returns the axis along which the lens is facing.

bool isLinear | ( |  | ) |

Returns true if the lens represents a linear projection (e.g.

PerspectiveLens, OrthographicLens), and therefore there is a valid matrix returned by get_projection_mat(), or false otherwise.

bool isOrthographic | ( |  | ) |

Returns true if the lens represents a orthographic projection (i.e.

it is a OrthographicLens), false otherwise.

bool isPerspective | ( |  | ) |

Returns true if the lens represents a perspective projection (i.e.

it is a PerspectiveLens), false otherwise.

BoundingVolume makeBounds | ( |  | ) |

Allocates and returns a new BoundingVolume that encloses the frustum used for this kind of lens, if possible.

If a suitable bounding volume cannot be created, returns NULL.

Lens makeCopy | ( |  | ) |

Geom makeGeometry | ( |  | ) |

Allocates and returns a new Geom that can be rendered to show a visible representation of the frustum used for this kind of lens, if it makes sense to do so.

If a visible representation cannot be created, returns NULL.

output | ( | ostream | out | ) |

bool project | ( | Point3 const | point3d,
|  | Point3 | point2d
| ) |  |

Given a 3-d point in space, determine the 2-d point this maps to, in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner.

The z coordinate will also be set to a value in the range (-1, 1), where 1 represents a point on the near plane, and -1 represents a point on the far plane.

Returns true if the 3-d point is in front of the lens and within the viewing frustum (in which case point2d is filled in), or false otherwise (in which case point2d will be filled in with something, which may or may not be meaningful).

bool project | ( | Point3 const | point3d,
|  | Point2 | point2d
| ) |  |

Given a 3-d point in space, determine the 2-d point this maps to, in the range (-1,1) in both dimensions, where (0,0) is the center of the lens and (-1,-1) is the lower-left corner.

Returns true if the 3-d point is in front of the lens and within the viewing frustum (in which case point2d is filled in), or false otherwise (in which case point2d will be filled in with something, which may or may not be meaningful).

recomputeAll | ( |  | ) |

Forces all internal parameters of the Lens to be recomputed.

Normally, this should never need to be called; it is provided only to assist in debugging.

setAspectRatio | ( | float | aspect_ratio | ) |

Sets the aspect ratio of the lens.

This is the ratio of the height to the width of the generated image. Setting this overrides the two-parameter fov or film size setting.

setChangeEvent | ( | string | event | ) |

Sets the name of the event that will be generated whenever any properties of the Lens have changed.

If this is not set for a particular lens, no event will be generated.

The event is thrown with one parameter, the lens itself. This can be used to automatically track changes to camera fov, etc. in the application.

setConvergenceDistance | ( | float | convergence_distance | ) |

Sets the distance between between the camera plane and the point in the distance that the left and right eyes are both looking at.

This distance is used to apply a stereo effect when the lens is rendered on a stereo display region. It only has an effect on a PerspectiveLens.

This parameter must be greater than 0, but may be as large as you like. It controls the amount to which the two eyes are directed inwards towards each other, which is a normal property of stereo vision. It is a distance, not an angle; normally this should be set to the distance from the camera to the area of interest in your scene. If you want to simulate parallel stereo, set this value to a very large number.

Also see set_interocular_distance(), which relates.

setCoordinateSystem | ( | CoordinateSystem | cs | ) |

Specifies the coordinate system that all 3-d computations are performed within for this Lens.

Normally, this is CS_default.

setFar | ( | float | far_distance | ) |

Defines the position of the far plane (or cylinder, sphere, whatever).

Points farther from the lens than this may not be rendered.

setFilmOffset | ( | VBase2 const | film_offset | ) |

Sets the horizontal and vertical offset amounts of this Lens.

These are both in the same units specified in set_film_size().

This can be used to establish an off-axis lens.

setFilmOffset | ( | float | x,
|  | float | y
| ) |  |

Sets the horizontal and vertical offset amounts of this Lens.

These are both in the same units specified in set_film_size().

This can be used to establish an off-axis lens.

setFilmSize | ( | VBase2 const | film_size | ) |

Sets the size and shape of the "film" within the lens.

This both establishes the units used by calls like set_focal_length(), and establishes the aspect ratio of the frame.

In a physical camera, the field of view of a lens is determined by the lens' focal length and by the size of the film area exposed by the lens. For instance, a 35mm camera exposes a rectangle on the film about 24mm x 36mm, which means a 50mm lens gives about a 40-degree horizontal field of view.

In the virtual camera, you may set the film size to any units here, and specify a focal length in the same units to simulate the same effect. Or, you may ignore this parameter, and specify the field of view and aspect ratio of the lens directly.

setFilmSize | ( | float | width,
|  | float | height
| ) |  |

Sets the size and shape of the "film" within the lens.

This both establishes the units used by calls like set_focal_length(), and establishes the aspect ratio of the frame.

In a physical camera, the field of view of a lens is determined by the lens' focal length and by the size of the film area exposed by the lens. For instance, a 35mm camera exposes a rectangle on the film about 24mm x 36mm, which means a 50mm lens gives about a 40-degree horizontal field of view.

In the virtual camera, you may set the film size to any units here, and specify a focal length in the same units to simulate the same effect. Or, you may ignore this parameter, and specify the field of view and aspect ratio of the lens directly.

setFilmSize | ( | float | width | ) |

Sets the horizontal size of the film without changing its shape.

The aspect ratio remains unchanged; this computes the vertical size of the film to automatically maintain the aspect ratio.

setFocalLength | ( | float | focal_length | ) |

Sets the focal length of the lens.

This may adjust the field-of-view correspondingly, and is an alternate way to specify field of view.

For certain kinds of lenses (e.g. OrthographicLens), the focal length has no meaning.

setFov | ( | float | fov | ) |

Sets the horizontal field of view of the lens without changing the aspect ratio.

The vertical field of view is adjusted to maintain the same aspect ratio.

setFov | ( | VBase2 const | fov | ) |

Sets the field of view of the lens in both dimensions.

This establishes both the field of view and the aspect ratio of the lens. This is one way to specify the field of view of a lens; set_focal_length() is another way.

For certain kinds of lenses (like OrthographicLens), the field of view has no meaning.

setFov | ( | float | hfov,
|  | float | vfov
| ) |  |

Sets the field of view of the lens in both dimensions.

This establishes both the field of view and the aspect ratio of the lens. This is one way to specify the field of view of a lens; set_focal_length() is another way.

For certain kinds of lenses (like OrthoLens), the field of view has no meaning.

setFrustumFromCorners | ( | VBase3 const | ul,
|  | VBase3 const | ur,
|  | VBase3 const | ll,
|  | VBase3 const | lr,
|  | int | flags
| ) |  |

Sets up the lens to use the frustum defined by the four indicated points.

This is most useful for a PerspectiveLens, but it may be called for other kinds of lenses as well.

The frustum will be rooted at the origin (or by whatever translation might have been specified in a previous call to set_view_mat).

It is legal for the four points not to be arranged in a rectangle; if this is the case, the frustum will be fitted as tightly as possible to cover all four points.

The flags parameter contains the union of one or more of the following bits to control the behavior of this function:

FC_roll - If this is included, the camera may be rotated so that its up vector is perpendicular to the top line. Otherwise, the standard up vector is used.

FC_camera_plane - This allows the camera plane to be adjusted to be as nearly perpendicular to the center of the frustum as possible. Without this bit, the orientation camera plane is defined by position of the four points (which should all be coplanar). With this bit, the camera plane is arbitarary, and may be chosen so that the four points do not themselves lie in the camera plane (but the points will still be within the frustum).

FC_off_axis - This allows the resulting frustum to be off-axis to get the tightest possible fit. Without this bit, the viewing axis will be centered within the frustum, but there may be more wasted space along the edges.

FC_aspect_ratio - This allows the frustum to be scaled non-proportionately in the vertical and horizontal dimensions, if necessary, to get a tighter fit. Without this bit, the current aspect ratio will be preserved.

FC_shear - This allows the frustum to be sheared, if necessary, to get the tightest possible fit. This may result in a parallelogram-based frustum, which will give a slanted appearance to the rendered image. Without this bit, the frustum will be rectangle-based.

In general, if 0 is passed in as the value for flags, the generated frustum will be a loose fit but sane; if -1 is passed in, it will be a tighter fit and possibly screwy.

setInterocularDistance | ( | float | interocular_distance | ) |

Sets the distance between the left and right eyes of a stereo camera.

This distance is used to apply a stereo effect when the lens is rendered on a stereo display region. It only has an effect on a PerspectiveLens.

The left eye and the right eye are each offset along the X axis by half of this distance, so that this parameter specifies the total distance between them.

Also see set_convergence_distance(), which relates.

setKeystone | ( | VBase2 const | keystone | ) |

Indicates the ratio of keystone correction to perform on the lens, in each of three axes.

This will build a special non-affine scale factor into the projection matrix that will compensate for keystoning of a projected image; this can be used to compensate for a projector that for physical reasons cannot be aimed directly at its screen.

The default value is taken from the default-keystone Config variable. 0, 0 indicates no keystone correction; specify a small value (usually in the range -1 .. 1) in either the x or y position to generate a keystone correction in that axis.

setMinFov | ( | float | min_fov | ) |

Sets the field of view of the smallest dimension of the window.

If the window is wider than it is tall, this specifies the vertical field of view; if it is taller than it is wide, this specifies the horizontal field of view.

In many cases, this is preferable to setting either the horizontal or vertical field of view explicitly. Setting this parameter means that pulling the window wider will widen the field of view, which is usually what you expect to happen.

setNear | ( | float | near_distance | ) |

Defines the position of the near plane (or cylinder, sphere, whatever).

Points closer to the lens than this may not be rendered.

setNearFar | ( | float | near_distance,
|  | float | far_distance
| ) |  |

Simultaneously changes the near and far planes.

setViewHpr | ( | VBase3 const | view_hpr | ) |

Sets the direction in which the lens is facing.

Normally, this is down the forward axis (usually the Y axis), but it may be rotated. This is only one way of specifying the rotation; you may also specify an explicit vector in which to look, or you may give a complete transformation matrix.

setViewHpr | ( | float | h,
|  | float | p,
|  | float | r
| ) |  |

Sets the direction in which the lens is facing.

Normally, this is down the forward axis (usually the Y axis), but it may be rotated. This is only one way of specifying the rotation; you may also specify an explicit vector in which to look, or you may give a complete transformation matrix.

setViewMat | ( | Mat4 const | view_mat | ) |

Sets an arbitrary transformation on the lens.

This replaces the individual transformation components like set_view_hpr().

Setting a transformation here will have a slightly different effect than putting one on the LensNode that contains this lens. In particular, lighting and other effects computations will still be performed on the lens in its untransformed (facing forward) position, but the actual projection matrix will be transformed by this matrix.

setViewVector | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | i,
|  | float | j,
|  | float | k
| ) |  |

Specifies the direction in which the lens is facing by giving an axis to look along, and a perpendicular (or at least non-parallel) up axis.

See also set_view_hpr().

setViewVector | ( | Vec3 const | view_vector,
|  | Vec3 const | up_vector
| ) |  |

Specifies the direction in which the lens is facing by giving an axis to look along, and a perpendicular (or at least non-parallel) up axis.

See also set_view_hpr().

write | ( | ostream | out | ) |

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties